Program Evoluce;

uses graph,
     crt;
const {max_pocet_jedincu = 64;}
      pravdepodobnost = 0.666666666667;
      pocet_genu = 2;
      min_gen = 0;
      max_gen = 639;
type Gen = min_gen..max_gen;
     Chromozom = record kombinace_genu : array [1..pocet_genu] of Gen;
                        poradi_dle_kvality, poradi_dle_diverzity, poradi : Integer {1..4 * max_pocet_jedincu};
                        kvalita, diverzita : Real;
                        vyradit : Boolean
                 end;
var populace : array [1..255] of Chromozom; {[1..4 * max_pocet_jedincu]}
    nova_populace : array [1..255] of Chromozom; {[1..max_pocet_jedincu]}
    pom_pop : Chromozom;
    vyhodit : Boolean;
    generace, vzdalenost : LongInt;
    max_pocet_jedincu, vyber, zmena, GrDriver, GrMode, ErrCode,
    i, j, k, l, m, nejlepsi, {0..4 * max_pocet_jedincu}
    pocet_rodicu, {1..max_pocet_jedincu}
    pocet_potomku : Integer; {0..3 * max_pocet_jedincu}
    diversity, quality, p : Real;
    klavesa : Char;

function f (a, b : Gen) : Real;
begin f := (sin(a/10) + a/100) * (sin(b/10) + b/100) end;

procedure inicializace;
begin ClrScr;
      writeln ('Program "Hledani maxima funkce genetickym algoritmem"');
      writeln;
      write ('Zadej pocet jedincu: '); read (max_pocet_jedincu);
      write ('Zadej velikost mutace: '); read (zmena);
      randomize;
      with populace [1] do
      begin for i := 1 to pocet_genu do kombinace_genu [i] := 0;
            kvalita := f (kombinace_genu [1], kombinace_genu [2]);
      end;
      pocet_rodicu := 1; pocet_potomku := 0;
end;

procedure mutovani;
var mez : Integer;
    mutovany_gen : Gen;
    pricist_zmenu : Boolean;
begin for i := 1 to pocet_rodicu do
      begin populace [pocet_rodicu + pocet_potomku + 1] := populace [i];
            with populace [pocet_rodicu + pocet_potomku + 1] do
            begin mutovany_gen := random (pocet_genu) + 1;
                  if mutovany_gen = 1 then mez := GetMaxX else mez := GetMaxY;
                  pricist_zmenu := odd (random (2));
                  if pricist_zmenu
                  then
                  begin if kombinace_genu [mutovany_gen] + zmena <= mez
                        then kombinace_genu [mutovany_gen] := kombinace_genu [mutovany_gen] + zmena
                  end
                  else if kombinace_genu [mutovany_gen] - zmena >= min_gen
                       then kombinace_genu [mutovany_gen] := kombinace_genu [mutovany_gen] - zmena;
                  kvalita := f (kombinace_genu [1], kombinace_genu [2]);
            end;
            vyhodit := false;
            for j := 1 to pocet_rodicu + pocet_potomku do
            begin l := 0;
                  for k := 1 to pocet_genu do
                  if populace[pocet_rodicu + pocet_potomku + 1].kombinace_genu[k] = populace[j].kombinace_genu[k]
                  then l := l + 1;
                  if l = pocet_genu then vyhodit := true
            end;
            if not vyhodit then pocet_potomku := pocet_potomku + 1;
      end;
end;

procedure crossover;
begin for i := 1 to pocet_rodicu do
      begin for j := 1 to pocet_rodicu do populace[j].vyradit := false;
            populace[i].vyradit := true;
            for j := 1 to pocet_rodicu - 1 do
            begin quality := -MaxLongInt;
                  for k := 1 to pocet_rodicu do
                  if (populace[k].kvalita > quality) and not populace[k].vyradit
                  then begin quality := populace[k].kvalita;
                             populace[k].poradi_dle_kvality := j;
                             nejlepsi := k;
                       end;
                  populace[nejlepsi].vyradit := true;
            end;
            for j := 1 to pocet_rodicu do populace[j].vyradit := false;
            populace[i].vyradit := true;
            for j := 1 to pocet_rodicu do if not populace[j].vyradit then
            begin vzdalenost := 0;
                  for k := 1 to pocet_genu do
vzdalenost := vzdalenost + LongInt (populace[j].kombinace_genu[k] - populace[i].kombinace_genu[k])
                         * LongInt (populace[j].kombinace_genu[k] - populace[i].kombinace_genu[k]);
                  populace[j].diverzita := 1 / vzdalenost
            end;
            for j := 1 to pocet_rodicu - 1 do
            begin diversity := MaxLongInt;
                  for k := 1 to pocet_rodicu do
                  if (populace[k].diverzita < diversity) and not populace[k].vyradit
                  then begin diversity := populace[k].diverzita;
                             populace[k].poradi_dle_diverzity := j;
                             nejlepsi := k;
                       end;
                  populace[nejlepsi].vyradit := true;
            end;
            for j := 1 to pocet_rodicu do populace[j].vyradit := false;
            populace[i].vyradit := true;
            for j := 1 to pocet_rodicu - 1 do
            begin quality := MaxLongInt; diversity := MaxLongInt;
                  for k := 1 to pocet_rodicu do
                  if ((populace[k].poradi_dle_kvality + populace[k].poradi_dle_diverzity < quality) or
                      (populace[k].poradi_dle_kvality + populace[k].poradi_dle_diverzity = quality) and
                       (populace[k].poradi_dle_diverzity < diversity)) and not populace[k].vyradit
                  then begin quality := populace[k].poradi_dle_kvality + populace[k].poradi_dle_diverzity;
                             diversity := populace[k].poradi_dle_diverzity;
                             populace[k].poradi := j;
                             nejlepsi := k;
                       end;
                  populace[nejlepsi].vyradit := true;
            end;
            vyber := random (1001); p := pravdepodobnost; j := 1;
            while (vyber / 1000 > p) and (j < pocet_rodicu - 1) do
            begin p := p + pravdepodobnost * (1 - pravdepodobnost);
                  j := j + 1
            end;
            k := 0;
            repeat k := k + 1 until populace[k].poradi = j;
            populace[pocet_rodicu + pocet_potomku + 1].kombinace_genu[1] := populace[i].kombinace_genu[1];
            populace[pocet_rodicu + pocet_potomku + 1].kombinace_genu[2] := populace[k].kombinace_genu[2];
            with populace [pocet_rodicu + pocet_potomku + 1] do
            kvalita := f (kombinace_genu [1], kombinace_genu [2]);
            vyhodit := false;
            for j := 1 to pocet_rodicu + pocet_potomku do
            begin l := 0;
                  for k := 1 to pocet_genu do
                  if populace[pocet_rodicu + pocet_potomku + 1].kombinace_genu[k] = populace[j].kombinace_genu[k]
                  then l := l + 1;
                  if l = pocet_genu then vyhodit := true
            end;
            if not vyhodit then pocet_potomku := pocet_potomku + 1;
            populace[pocet_rodicu + pocet_potomku + 1].kombinace_genu[1] := populace[k].kombinace_genu[1];
            populace[pocet_rodicu + pocet_potomku + 1].kombinace_genu[2] := populace[i].kombinace_genu[2];
            with populace [pocet_rodicu + pocet_potomku + 1] do
            kvalita := f (kombinace_genu [1], kombinace_genu [2]);
            vyhodit := false;
            for j := 1 to pocet_rodicu + pocet_potomku do
            begin l := 0;
                  for k := 1 to pocet_genu do
                  if populace[pocet_rodicu + pocet_potomku + 1].kombinace_genu[k] = populace[j].kombinace_genu[k]
                  then l := l + 1;
                  if l = pocet_genu then vyhodit := true
            end;
            if not vyhodit then pocet_potomku := pocet_potomku + 1
      end;
end;

procedure redukce;
begin for j := 1 to pocet_rodicu + pocet_potomku do populace[j].vyradit := false;
      for j := 1 to pocet_rodicu + pocet_potomku do
      begin quality := -MaxLongInt;
            for k := 1 to pocet_rodicu + pocet_potomku do
            if (populace[k].kvalita > quality) and not populace[k].vyradit
            then begin quality := populace[k].kvalita;
                       populace[k].poradi_dle_kvality := j;
                       nejlepsi := k;
                 end;
            populace[nejlepsi].vyradit := true;
      end;
      vyber := random (1001); p := pravdepodobnost; j := 1;
      while (vyber / 1000 > p) and (j < pocet_rodicu + pocet_potomku) do
      begin p := p + pravdepodobnost * (1 - pravdepodobnost);
            j := j + 1
      end;
      k := 0;
      repeat k := k + 1 until populace[k].poradi_dle_kvality = j;
      nova_populace [1] := populace [k];
      pom_pop := populace[k];
      populace [k] := populace [pocet_rodicu + pocet_potomku];
      populace [pocet_rodicu + pocet_potomku] := pom_pop;
      for i := 1 to max_pocet_jedincu - 1 do
      begin for j := 1 to pocet_rodicu + pocet_potomku - i do populace[j].vyradit := false;
            for j := 1 to pocet_rodicu + pocet_potomku - i do
            begin quality := -MaxLongInt;
                  for k := 1 to pocet_rodicu + pocet_potomku - i do
                  if (populace[k].kvalita > quality) and not populace[k].vyradit
                  then begin quality := populace[k].kvalita;
                             populace[k].poradi_dle_kvality := j;
                             nejlepsi := k;
                       end;
                  populace[nejlepsi].vyradit := true;
            end;
            for j := 1 to pocet_rodicu + pocet_potomku - i do populace[j].vyradit := false;
            for j := 1 to pocet_rodicu + pocet_potomku - i do
            begin populace[j].diverzita := 0;
                  for l := 1 to i do
                  begin vzdalenost := 0;
                        for k := 1 to pocet_genu do
vzdalenost := vzdalenost + LongInt (populace[j].kombinace_genu[k] - nova_populace[l].kombinace_genu[k])
                         * LongInt (populace[j].kombinace_genu[k] - nova_populace[l].kombinace_genu[k]);
                        populace[j].diverzita := populace[j].diverzita + 1 / vzdalenost
                  end;
            end;
            for j := 1 to pocet_rodicu + pocet_potomku - i do
            begin diversity := MaxLongInt;
                  for k := 1 to pocet_rodicu + pocet_potomku - i do
                  if (populace[k].diverzita < diversity) and not populace[k].vyradit
                  then begin diversity := populace[k].diverzita;
                             populace[k].poradi_dle_diverzity := j;
                             nejlepsi := k;
                       end;
                  populace[nejlepsi].vyradit := true;
            end;
            for j := 1 to pocet_rodicu + pocet_potomku - i do populace[j].vyradit := false;
            for j := 1 to pocet_rodicu + pocet_potomku - i do
            begin quality := MaxLongInt; diversity := MaxLongInt;
                  for k := 1 to pocet_rodicu + pocet_potomku - i do
                  if ((populace[k].poradi_dle_kvality + populace[k].poradi_dle_diverzity < quality) or
                      (populace[k].poradi_dle_kvality + populace[k].poradi_dle_diverzity = quality) and
                       (populace[k].poradi_dle_diverzity < diversity)) and not populace[k].vyradit
                  then begin quality := populace[k].poradi_dle_kvality + populace[k].poradi_dle_diverzity;
                             diversity := populace[k].poradi_dle_diverzity;
                             populace[k].poradi := j;
                             nejlepsi := k;
                       end;
                  populace[nejlepsi].vyradit := true;
            end;
            vyber := random (1001); p := pravdepodobnost; j := 1;
            while (vyber / 1000 > p) and (j < pocet_rodicu + pocet_potomku - i) do
            begin p := p + pravdepodobnost * (1 - pravdepodobnost);
                  j := j + 1
            end;
            k := 0;
            repeat k := k + 1 until populace[k].poradi = j;
            nova_populace [i + 1] := populace [k];
            pom_pop := populace [k];
            populace [k] := populace [pocet_rodicu + pocet_potomku - i];
            populace [pocet_rodicu + pocet_potomku - i] := pom_pop;
      end;
      for i := 1 to max_pocet_jedincu do populace [i] := nova_populace [i];
      pocet_rodicu := max_pocet_jedincu;
      pocet_potomku := 0;
end;

procedure kresleni;
begin ClearDevice;
      for i := 1 to pocet_rodicu do
      with populace [i] do
      PutPixel (kombinace_genu [1], kombinace_genu [2], 15)
end;

begin inicializace;
      GrDriver := detect;
      InitGraph (GrDriver, GrMode,'');
      ErrCode := GraphResult;
      if ErrCode = GrOK then
      repeat mutovani;
             if pocet_rodicu > 1 then crossover;
             if pocet_rodicu + pocet_potomku > max_pocet_jedincu then redukce;
             pocet_rodicu := pocet_rodicu + pocet_potomku;
             pocet_potomku := 0;
             generace := generace + 1;
             kresleni
      until keypressed
      else writeln('Chyba grafiky: ', GraphErrorMsg(ErrCode));
      klavesa := ReadKey;
      RestoreCrtMode;
      writeln ('Pocet generaci: ', generace)
end.