Program Neuronova_sit_geneticky;

uses graph,
     crt;

const pravdepodobnost = 0.666666666667;
      max_pocet_jedincu = 10;
      p_mutace_genu = 50;
      prah = -1;
      n = 13;

type Vrstva1_2 = array [1..n, 1..n] of Real; {[1..vrstva1 + 1, 1..vrstva2]}
     Vrstva2_3 = array [1..n, 1..2] of Real; {[1..vrstva2 + 1, 1..vrstva3]}
     Chromozom = record w1 : Vrstva1_2;
                        w2 : Vrstva2_3;
                        poradi_dle_kvality, poradi_dle_diverzity, poradi : 1..4 * max_pocet_jedincu;
                        kvalita, diverzita : Real;
                        vyradit : Boolean
                 end;

var f, fs, fv, fp : Text;
    fw, fd : file of Real;
    klavesa : Char;
    c : Word; {astost vpisu performance}
    generace : LongInt;
    vyhodit, vahy_hotovy : Boolean;
    populace : array [1..4 * max_pocet_jedincu] of Chromozom;
    nova_populace : array [1..max_pocet_jedincu] of Chromozom;
    pom_pop : Chromozom;
    pocet_genu, vyber, i, j, k, ii, jj, kk, l, m,
    vrstva1, vrstva2, vrstva3 : Integer;
    nejlepsi, vyhov : 0..4 * max_pocet_jedincu;
    pocet_rodicu : 1..max_pocet_jedincu;
    pocet_potomku : 0..3 * max_pocet_jedincu;
    x : array [1..n] of Real; {[1..vrstva1 + 1]}
    suma1, vystup1 : array [1..n] of Real; {[1..vrstva2 + 1]}
    suma2, vystup2, spravny_vystup : array [1..2] of Real; {[1..vrstva3]}
    r, presnost, vzdalenost, diversity, quality, p : Real;

function Performance
(porad : Integer; vaha1 : Vrstva1_2; vaha2 : Vrstva2_3) : Real;
var i, j, k : Integer;
    perform : Real;
begin reset (fd); perform := 0; vahy_hotovy := true;
      while not EOF (fd) do
      begin for i := 1 to vrstva1 do read (fd, x [i]);
            for k := 1 to vrstva3 do read (fd, spravny_vystup [k]);
            for j := 1 to vrstva2 do
            begin suma1 [j] := 0;
                  for i := 1 to vrstva1 + 1 do
                  suma1 [j] := suma1 [j] + x [i] * vaha1 [i,j];
                  vystup1 [j] := 1 / (1 + exp (-suma1 [j]))
            end;
            for k := 1 to vrstva3 do
            begin suma2 [k] := 0;
                  for j := 1 to vrstva2 + 1 do
                  suma2 [k] := suma2 [k] + vystup1 [j] * vaha2 [j,k];
                  vystup2 [k] := 1 / (1 + exp (-suma2 [k]));
                  perform := perform - sqr (spravny_vystup [k] - vystup2 [k]);
                  if abs (spravny_vystup [k] - vystup2 [k]) > presnost
                  then vahy_hotovy := false;
             end;
      end;
      performance := perform;
      if vahy_hotovy then vyhov := porad
end;

procedure inicializace;
begin ClrScr;
      WriteLn ('Program "Neuronov s potan genetickm algoritmem"');
      WriteLn ('Nastaven mus bt v souboru "setup.txt".');
      WriteLn ('Data mus bt v souboru "data.txt".');
      assign (f, 'data.txt');
      assign (fd, 'data.dat');
      assign (fp, 'perform.txt');
      assign (fv, 'vysledek.txt');
      assign (fw, 'vahy.dat');
      assign (fs, 'setup.txt');
      reset (fs);
      ReadLn (fs, vrstva1);
      ReadLn (fs, vrstva2);
      ReadLn (fs, vrstva3);
      ReadLn (fs, presnost);
      ReadLn (fs, r);
      ReadLn (fs, c);
      close (fs);
      x [vrstva1 + 1] := prah;
      vystup1 [vrstva2 + 1] := prah;
      pocet_genu := vrstva1 * vrstva2 + vrstva2 * vrstva3 + vrstva2 + vrstva3;
      generace := 0;
      randomize;
      pocet_rodicu := 1; pocet_potomku := 0;
      reset (f); rewrite (fd);
      while SeekEOF (f) = false do
      begin for i := 1 to vrstva1 do begin read (f, x [i]); write (fd, x [i]) end;
            for k := 1 to vrstva3 do begin read (f, spravny_vystup [k]); write (fd, spravny_vystup [k]) end
      end;
      close (f); close (fd);
end;

procedure mutovani;
var mutovat : Boolean;
begin for i := 1 to pocet_rodicu do
      begin populace [pocet_rodicu + pocet_potomku + 1] := populace [i];
            with populace [pocet_rodicu + pocet_potomku + 1] do
            begin for ii := 1 to vrstva1 + 1 do for jj := 1 to vrstva2 do
                  begin mutovat := random (100) < P_mutace_genu;
                        if mutovat then w1 [ii,jj] := w1 [ii,jj] + r * (random (1000) / 10000 - 0.05)
                  end;
                  for jj := 1 to vrstva2 + 1 do for kk := 1 to vrstva3 do
                  begin mutovat := random (100) < P_mutace_genu;
                        if mutovat then w2 [jj,kk] := w2 [jj,kk] + r * (random (1000) / 10000 - 0.05)
                  end;

            end;
            vyhodit := false;
            for j := 1 to pocet_rodicu + pocet_potomku do
            begin l := 0;
                  for ii := 1 to vrstva1 + 1 do for jj := 1 to vrstva2 do
if populace[pocet_rodicu + pocet_potomku + 1].w1[ii,jj] = populace[j].w1[ii,jj]
then l := l + 1;
                  for jj := 1 to vrstva2 + 1 do for kk := 1 to vrstva3 do
if populace[pocet_rodicu + pocet_potomku + 1].w2[jj,kk] = populace[j].w2[jj,kk]
then l := l + 1;
                  if l = pocet_genu then vyhodit := true
            end;
            if not vyhodit then
            begin pocet_potomku := pocet_potomku + 1;
                  with populace [pocet_rodicu + pocet_potomku] do
                  kvalita := performance (pocet_rodicu + pocet_potomku, w1, w2)
            end;
      end;
end;

procedure crossover;
begin for i := 1 to pocet_rodicu do
      begin for j := 1 to pocet_rodicu do populace[j].vyradit := false;
            populace[i].vyradit := true;
            for j := 1 to pocet_rodicu - 1 do
            begin quality := -MaxLongInt;
                  for k := 1 to pocet_rodicu do
                  if (populace[k].kvalita > quality) and not populace[k].vyradit
                  then begin quality := populace[k].kvalita;
                             populace[k].poradi_dle_kvality := j;
                             nejlepsi := k;
                       end;
                  populace[nejlepsi].vyradit := true;
            end;
            for j := 1 to pocet_rodicu do populace[j].vyradit := false;
            populace[i].vyradit := true;
            for j := 1 to pocet_rodicu do if not populace[j].vyradit then
            begin vzdalenost := 0;
                  for ii := 1 to vrstva1 + 1 do for jj := 1 to vrstva2 do
vzdalenost := vzdalenost + sqr (populace[j].w1[ii,jj] - populace[i].w1[ii,jj]);
                  for jj := 1 to vrstva2 + 1 do for kk := 1 to vrstva3 do
vzdalenost := vzdalenost + sqr (populace[j].w2[jj,kk] - populace[i].w2[jj,kk]);
                  populace[j].diverzita := 1 / vzdalenost
            end;
            for j := 1 to pocet_rodicu - 1 do
            begin diversity := MaxLongInt;
                  for k := 1 to pocet_rodicu do
                  if (populace[k].diverzita < diversity) and not populace[k].vyradit
                  then begin diversity := populace[k].diverzita;
                             populace[k].poradi_dle_diverzity := j;
                             nejlepsi := k;
                       end;
                  populace[nejlepsi].vyradit := true;
            end;
            for j := 1 to pocet_rodicu do populace[j].vyradit := false;
            populace[i].vyradit := true;
            for j := 1 to pocet_rodicu - 1 do
            begin quality := MaxLongInt; diversity := MaxLongInt;
                  for k := 1 to pocet_rodicu do
                  if ((populace[k].poradi_dle_kvality + populace[k].poradi_dle_diverzity < quality) or
                      (populace[k].poradi_dle_kvality + populace[k].poradi_dle_diverzity = quality) and
                       (populace[k].poradi_dle_diverzity < diversity)) and not populace[k].vyradit
                  then begin quality := populace[k].poradi_dle_kvality + populace[k].poradi_dle_diverzity;
                             diversity := populace[k].poradi_dle_diverzity;
                             populace[k].poradi := j;
                             nejlepsi := k;
                       end;
                  populace[nejlepsi].vyradit := true;
            end;
            vyber := random (1001); p := pravdepodobnost; j := 1;
            while (vyber / 1000 > p) and (j < pocet_rodicu - 1) do
            begin p := p + pravdepodobnost * (1 - pravdepodobnost);
                  j := j + 1
            end;
            k := 0;
            repeat k := k + 1 until populace[k].poradi = j;
            populace[pocet_rodicu + pocet_potomku + 1].w1 := populace[i].w1;
            populace[pocet_rodicu + pocet_potomku + 1].w2 := populace[k].w2;
            vyhodit := false;
            for j := 1 to pocet_rodicu + pocet_potomku do
            begin l := 0;
                  for ii := 1 to vrstva1 + 1 do for jj := 1 to vrstva2 do
if populace[pocet_rodicu + pocet_potomku + 1].w1[ii,jj] = populace[j].w1[ii,jj]
then l := l + 1;
                  for jj := 1 to vrstva2 + 1 do for kk := 1 to vrstva3 do
if populace[pocet_rodicu + pocet_potomku + 1].w2[jj,kk] = populace[j].w2[jj,kk]
then l := l + 1;
                  if l = pocet_genu then vyhodit := true
            end;
            if not vyhodit then
            begin pocet_potomku := pocet_potomku + 1;
                  with populace [pocet_rodicu + pocet_potomku] do
                  kvalita := performance (pocet_rodicu + pocet_potomku, w1, w2)
            end;
            populace[pocet_rodicu + pocet_potomku + 1].w1 := populace[k].w1;
            populace[pocet_rodicu + pocet_potomku + 1].w2 := populace[i].w2;
            vyhodit := false;
            for j := 1 to pocet_rodicu + pocet_potomku do
            begin l := 0;
                  for ii := 1 to vrstva1 + 1 do for jj := 1 to vrstva2 do
if populace[pocet_rodicu + pocet_potomku + 1].w1[ii,jj] = populace[j].w1[ii,jj]
then l := l + 1;
                  for jj := 1 to vrstva2 + 1 do for kk := 1 to vrstva3 do
if populace[pocet_rodicu + pocet_potomku + 1].w2[jj,kk] = populace[j].w2[jj,kk]
then l := l + 1;
                  if l = pocet_genu then vyhodit := true
            end;
            if not vyhodit then
            begin pocet_potomku := pocet_potomku + 1;
                  with populace [pocet_rodicu + pocet_potomku] do
                  kvalita := performance (pocet_rodicu + pocet_potomku, w1, w2)
            end;
      end;
      if (pocet_rodicu + pocet_potomku <= max_pocet_jedincu)
      then begin pocet_rodicu := pocet_rodicu + pocet_potomku;
                 pocet_potomku := 0;
           end;
end;

procedure redukce;
begin for j := 1 to pocet_rodicu + pocet_potomku do populace[j].vyradit := false;
      for j := 1 to pocet_rodicu + pocet_potomku do
      begin quality := -MaxLongInt;
            for k := 1 to pocet_rodicu + pocet_potomku do
            if (populace[k].kvalita > quality) and not populace[k].vyradit
            then begin quality := populace[k].kvalita;
                       populace[k].poradi_dle_kvality := j;
                       nejlepsi := k;
                 end;
            populace[nejlepsi].vyradit := true;
      end;
      vyber := random (1001); p := pravdepodobnost; j := 1;
      while (vyber / 1000 > p) and (j < pocet_rodicu + pocet_potomku) do
      begin p := p + pravdepodobnost * (1 - pravdepodobnost);
            j := j + 1
      end;
      k := 0;
      repeat k := k + 1 until populace[k].poradi_dle_kvality = j;
      nova_populace [1] := populace [k];
      pom_pop := populace[k];
      populace [k] := populace [pocet_rodicu + pocet_potomku];
      populace [pocet_rodicu + pocet_potomku] := pom_pop;
      for i := 1 to max_pocet_jedincu - 1 do
      begin for j := 1 to pocet_rodicu + pocet_potomku - i do populace[j].vyradit := false;
            for j := 1 to pocet_rodicu + pocet_potomku - i do
            begin quality := -MaxLongInt;
                  for k := 1 to pocet_rodicu + pocet_potomku - i do
                  if (populace[k].kvalita > quality) and not populace[k].vyradit
                  then begin quality := populace[k].kvalita;
                             populace[k].poradi_dle_kvality := j;
                             nejlepsi := k;
                       end;
                  populace[nejlepsi].vyradit := true;
            end;
            for j := 1 to pocet_rodicu + pocet_potomku - i do populace[j].vyradit := false;
            for j := 1 to pocet_rodicu + pocet_potomku - i do
            begin populace[j].diverzita := 0;
                  for l := 1 to i do
                  begin vzdalenost := 0;
                        for ii := 1 to vrstva1 + 1 do for jj := 1 to vrstva2 do
vzdalenost := vzdalenost + sqr (populace[j].w1[ii,jj] - nova_populace[l].w1[ii,jj]);
                        for jj := 1 to vrstva2 + 1 do for kk := 1 to vrstva3 do
vzdalenost := vzdalenost + sqr (populace[j].w2[jj,kk] - nova_populace[l].w2[jj,kk]);
                        populace[j].diverzita := populace[j].diverzita + 1 / vzdalenost
                  end;
            end;
            for j := 1 to pocet_rodicu + pocet_potomku - i do
            begin diversity := MaxLongInt;
                  for k := 1 to pocet_rodicu + pocet_potomku - i do
                  if (populace[k].diverzita < diversity) and not populace[k].vyradit
                  then begin diversity := populace[k].diverzita;
                             populace[k].poradi_dle_diverzity := j;
                             nejlepsi := k;
                       end;
                  populace[nejlepsi].vyradit := true;
            end;
            for j := 1 to pocet_rodicu + pocet_potomku - i do populace[j].vyradit := false;
            for j := 1 to pocet_rodicu + pocet_potomku - i do
            begin quality := MaxLongInt; diversity := MaxLongInt;
                  for k := 1 to pocet_rodicu + pocet_potomku - i do
                  if ((populace[k].poradi_dle_kvality + populace[k].poradi_dle_diverzity < quality) or
                      (populace[k].poradi_dle_kvality + populace[k].poradi_dle_diverzity = quality) and
                       (populace[k].poradi_dle_diverzity < diversity)) and not populace[k].vyradit
                  then begin quality := populace[k].poradi_dle_kvality + populace[k].poradi_dle_diverzity;
                             diversity := populace[k].poradi_dle_diverzity;
                             populace[k].poradi := j;
                             nejlepsi := k;
                       end;
                  populace[nejlepsi].vyradit := true;
            end;
            vyber := random (1001); p := pravdepodobnost; j := 1;
            while (vyber / 1000 > p) and (j < pocet_rodicu + pocet_potomku - i) do
            begin p := p + pravdepodobnost * (1 - pravdepodobnost);
                  j := j + 1
            end;
            k := 0;
            repeat k := k + 1 until populace[k].poradi = j;
            nova_populace [i + 1] := populace [k];
            pom_pop := populace [k];
            populace [k] := populace [pocet_rodicu + pocet_potomku - i];
            populace [pocet_rodicu + pocet_potomku - i] := pom_pop;
      end;
      for i := 1 to max_pocet_jedincu do populace [i] := nova_populace [i];
      pocet_rodicu := max_pocet_jedincu;
      pocet_potomku := 0;
end;

function vyhovujici : Integer;
var max_kvalita : Real;
    poradi_vyhovujiciho : 0..4 * max_pocet_jedincu;
begin max_kvalita := -MaxLongInt;
      for i := 1 to pocet_rodicu + pocet_potomku do
      begin if populace[i].kvalita > max_kvalita then
            begin max_kvalita := populace[i].kvalita;
                  poradi_vyhovujiciho := i
            end;
      end;
      vyhovujici := poradi_vyhovujiciho;
end;

procedure pracuj;
begin rewrite (fp);
      repeat mutovani;
             if (pocet_rodicu > 1) and not vahy_hotovy
             then crossover;
             if (pocet_rodicu + pocet_potomku > max_pocet_jedincu) and not vahy_hotovy
             then redukce;
             generace := generace + 1;
             if generace mod c = 0 then WriteLn (fp, -populace[vyhovujici].kvalita :0 :6, #9)
      until vahy_hotovy or KeyPressed and (generace mod c = 0);
      close (fp)
end;

procedure vysledek;
begin if not vahy_hotovy then vyhov := vyhovujici;
      with populace [vyhov] do
      begin
      reset (fd);
      rewrite (fv);
      WriteLn (fv, 'Vsledek uen neuronov st'); WriteLn (fv);
      for i := 1 to vrstva1 + 1 do for j := 1 to vrstva2 do
      WriteLn (fv, 'vha 1 ', i:3, j:3, #9, w1 [i,j] :7 :3);
      for j := 1 to vrstva2 + 1 do for k := 1 to vrstva3 do
      WriteLn (fv, 'vha 2 ', j:3, k:3, #9, w2 [j,k] :7 :3);
      WriteLn (fv);
      while not EOF (fd) do
      begin for i := 1 to vrstva1 do read (fd, x [i]);
            for k := 1 to vrstva3 do read (fd, spravny_vystup [k]);
            for j := 1 to vrstva2 do
            begin suma1 [j] := 0;
                  for i := 1 to vrstva1 + 1 do suma1 [j] := suma1 [j] + x [i] * w1 [i,j];
                  vystup1 [j] := 1 / (1 + exp (-suma1 [j]))
            end;
            for k := 1 to vrstva3 do
            begin suma2 [k] := 0;
                  for j := 1 to vrstva2 + 1 do suma2 [k] := suma2 [k] + vystup1 [j] * w2 [j,k];
                  vystup2 [k] := 1 / (1 + exp (-suma2 [k]));
                  writeln (fv, spravny_vystup [k] :7 :3, #9, vystup2 [k] :7 :3, #9, spravny_vystup [k] - vystup2 [k] :7 :3)
            end;
      end;
      writeln (fv);
      writeln (fv, 'Poet generac: ', generace, '.');
      writeln ('Vsledek je v souboru "vysledek.txt".');
      rewrite (fw);
      for i := 1 to vrstva1 + 1 do for j := 1 to vrstva2 do write (fw, w1 [i,j]);
      for j := 1 to vrstva2 + 1 do for k := 1 to vrstva3 do write (fw, w2 [j,k]);
      close (fv); close (fd); close (fw)
      end;
end;

begin inicializace;
      WriteLn ('Zante-li uit, stisknte klvesu "N".');
      WriteLn ('Pokraujete-li v uen, stisknte klvesu "P".');
      WriteLn ('Zadte-li cokoli jinho, s zpracuje data bez uen.');
      klavesa := ReadKey; WriteLn (klavesa);
      case klavesa of
      'n', 'N' : begin with populace [1] do
                       begin for i := 1 to vrstva1 + 1 do for j := 1 to vrstva2 do w1 [i,j] := random (1000) / 1000 - 0.5;
                             for j := 1 to vrstva2 + 1 do for k := 1 to vrstva3 do w2 [j,k] := random (1000) / 1000 - 0.5;
                             kvalita := performance (1, w1, w2)
                       end;
                       pracuj; vysledek
                 end;
      'p', 'P' : begin reset (fw);
                       with populace [1] do
                       begin for i := 1 to vrstva1 + 1 do for j := 1 to vrstva2 do read (fw, w1 [i,j]);
                             for j := 1 to vrstva2 + 1 do for k := 1 to vrstva3 do read (fw, w2 [j,k]);
                             kvalita := performance (1, w1, w2)
                       end;
                       pracuj; vysledek
                 end;
      else       begin reset (fw);
                       with populace [1] do
                       begin for i := 1 to vrstva1 + 1 do for j := 1 to vrstva2 do read (fw, w1 [i,j]);
                             for j := 1 to vrstva2 + 1 do for k := 1 to vrstva3 do read (fw, w2 [j,k]);
                             kvalita := performance (1, w1, w2)
                       end;
                       vysledek
                 end;
      end;
end.